#include <windows.h>
#include "meshmanager.h"
#include "meshobject.h"

CMeshMManager* Meshes::MeshManager = NULL;

extern void Meshes::InitMeshManager()
{
	if( !MeshManager )MeshManager = new CMeshMManager;
};

extern void Meshes::DoneMeshManager()
{
	SAFE_DELETE( MeshManager );
};

extern CMeshMManager* Meshes::GetMeshManager()
{
	return MeshManager;
};

CMMMesh* CMeshMManager::CreateMeshObject( MeshTypes TYPE )
{
	CMMMesh* Obj = NULL;

	switch( TYPE )
	{
		case MESH_SIMPLE:
			Obj = new CMMMesh;
			break;
		default:
			Obj = NULL;
	};
	if( Obj ) ObjList.push_back( Obj );
	return Obj;
};

CMMMesh* CMeshMManager::FindMesh( LPWSTR FILENAME )
{
	CMMMesh* Obj = NULL;
	for( MMObjIter i = ObjList.begin(); i != ObjList.end(); ++i )
	{
		Obj = (CMMMesh*)( *i );
		if( Obj->GetMeshFileName() == FILENAME ) return Obj;
	};
	return NULL;
};