#include <windows.h>
#include <list>
#include "mmanager.h"

void CMManager::AddObject( CMMObject* OBJ )
{
	ObjList.push_back( OBJ );
};

void CMManager::RemoveObject( CMMObject* OBJ )
{
	ObjList.remove( OBJ );
};

CMMObject* CMManager::GetObject( LPWSTR NAME, int TAG )
{
	for( MMObjIter i = ObjList.begin(); i != ObjList.end(); ++i )
	{
		CMMObject* Obj = ( *i );
		if( Obj->GetName() == NAME && Obj->GetTag() == TAG) return Obj;
	};
	return NULL;
};

void CMManager::DeleteGarbage()
{
	for( MMObjIter i = ObjList.begin(); i != ObjList.end(); )
	{
		CMMObject* Obj = ( *i );
		if( Obj->GetRefCount() == 0 )
		{
			SAFE_DELETE( Obj );
			i = ObjList.erase( i );
		}
		else
		{
			++i;
		};
	};
};

void CMManager::ClearList()
{
	ObjList.clear();
};

void CMManager::DeleteAll()
{
	MMObjIter i = ObjList.begin();
	while( i != ObjList.end() )
	{
		CMMObject* Obj = ( *i );
		SAFE_DELETE( Obj );
		i = ObjList.erase( i );
	};
};