#ifndef _PARTICLESYSTEM_H_INCLUDED_
#define _PARTICLESYSTEM_H_INCLUDED_

#include <windows.h>
#include <d3dx9.h>
#include "particleobject.h"
#include "textureobject.h"

class CMMParticleSystem;
	
typedef void (CALLBACK *LPInitParticle)( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX, bool FIRSTTIME ); 
typedef bool (CALLBACK *LPIsParticleAlive)( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX ); 
typedef void (CALLBACK *LPUpdateParticle)( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX ); 

class CMMParticleSystem : public CMMObject
{
public:
	CMMParticleSystem() : CMMObject(), particles( NULL ), particlenum( 0 ),
		particlesize( 0.0f ), initparticle( NULL ), updateparticle( NULL ),
		isparticlealive( NULL ), texture( NULL ), animated( false ),
		particle( NULL ) {};
	CMMParticleSystem( LPWSTR NAME, int TAG ) : CMMObject( NAME, TAG ), particles( NULL ),
		particlesize( 0.0f ), particlenum( 0 ), initparticle( NULL ), updateparticle( NULL ),
		isparticlealive( NULL ), texture( NULL ), animated( false ),
		particle( NULL ) {};
	~CMMParticleSystem() { CleanUp(); };
	virtual void CleanUp();
	virtual void Reset( LPDIRECT3DDEVICE9 DEVICE, int PARTICLENUM, float PARTICLESIZE,
		LPInitParticle INITPARTICLE, LPUpdateParticle UPDATEPARTICLE,
		LPIsParticleAlive ISPARTICLEALIVE, CMMTexture* TEXTURE, bool ANIMATED );
	virtual void Update( int UPDATES = 1 );
	virtual CMMParticle* GetParticle( int PARTICLEINDEX );
	virtual void SetTexture( CMMTexture* TEXTURE, bool ANIMATED );
	virtual void Draw( LPDIRECT3DDEVICE9 DEVICE );
protected:
	CMMParticle** particles;
	int particlenum;
	float particlesize;
	LPInitParticle initparticle;
	LPUpdateParticle updateparticle;
	LPIsParticleAlive isparticlealive;
	CMMTexture* texture;
	bool animated;
	LPD3DXSPRITE particle;
};

#endif // #ifndef _PARTICLESYSTEM_H_INCLUDED_